#include "cmd_processer_server.h"
#include "mqtt_request.h"

namespace offcn
{
	static const std::string kGlobalTopic = "kcp_server_mqtt";
	static const std::string kLocalID = "kcp_server_mqtt";

	CmdProcesserServer::CmdProcesserServer()
		:mqtt_wrapper_(NULL)
	{
		mqtt_wrapper_ = new offcn::MqttWrapper(this);
	}
	CmdProcesserServer::~CmdProcesserServer()
	{
		if (mqtt_wrapper_)
		{
			delete mqtt_wrapper_;
			mqtt_wrapper_ = NULL;
		}
	}

	bool CmdProcesserServer::Connect()
	{
		return mqtt_wrapper_->ConnectMqttServer(kLocalID);
	}
	bool CmdProcesserServer::SubscribeTopic()
	{
		return mqtt_wrapper_->SubscribeTopic(kGlobalTopic);
	}

	/**
	 * CmdObserver
	 */
	void CmdProcesserServer::OnServerConnectSuccess()
	{
		printf("connect mqtt server success!\n");

		SubscribeTopic();
	}
	void CmdProcesserServer::OnServerConnectFailure()
	{
		printf("connect mqtt server failure!\n");
	}
	void CmdProcesserServer::OnServerSubscribeSuccess()
	{
		printf("subscribe topic success!\n");
	}
	void CmdProcesserServer::OnServerSubscribeFailure()
	{
		printf("subscribe topic failure!\n");
	}
	void CmdProcesserServer::OnServerMessageArrived(std::string topic, std::string message)
	{
		printf("\nreceive message : topic = %s, context : %s\n", topic.c_str(), message.c_str());
	}
}