#include "cmd_processer_client.h"
#include "mqtt_request.h"

namespace offcn
{
	static const std::string kGlobalTopic = "kcp_server_mqtt";
	static const std::string kLocalID = "mqtt_client";
	static const std::string kDstTopic = kLocalID;

	CmdProcesserClient::CmdProcesserClient()
		:mqtt_wrapper_(NULL)
	{
		mqtt_wrapper_ = new offcn::MqttWrapper(this);
	}
	CmdProcesserClient::~CmdProcesserClient()
	{
		if (mqtt_wrapper_)
		{
			delete mqtt_wrapper_;
			mqtt_wrapper_ = NULL;
		}
	}

	bool CmdProcesserClient::Connect()
	{
		return mqtt_wrapper_->ConnectMqttServer(kLocalID);
	}
	bool CmdProcesserClient::SubscribeTopic()
	{
		return mqtt_wrapper_->SubscribeTopic(kLocalID);
	}

	/**
	 * CmdObserver
	 */
	void CmdProcesserClient::OnServerConnectSuccess()
	{
		printf("connect mqtt server success!\n");
		SubscribeTopic();
	}
	void CmdProcesserClient::OnServerConnectFailure()
	{
		printf("connect mqtt server failure!\n");
	}
	void CmdProcesserClient::OnServerSubscribeSuccess()
	{
		printf("subscribe topic success!\n");
		
		std::string topic = kGlobalTopic;
		std::string req = MqttRequest::JoinRequest(kLocalID);;

		mqtt_wrapper_->SendRequest(topic, req);
	}
	void CmdProcesserClient::OnServerSubscribeFailure()
	{
		printf("subscribe topic failure!\n");
	}
	void CmdProcesserClient::OnServerMessageArrived(std::string topic, std::string message)
	{

	}
}